function flow = ComputeFlows(f, maxIt, smooth)

% Copyright 2019 Laurent Hoeltgen <contact@laurenthoeltgen.name>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision on: 19.08.19 11:21

[nr, nc, ~] = size(f);              % get image size
flow = zeros(nr, nc, 2, size(f,3) - 1); % initialise flow

% Compute optical flow
OF = opticalFlowHS('MaxIteration', maxIt, 'Smoothness', smooth);
OF.estimateFlow(f(:,:,1));
for ii = 2:size(f,3)
    flowtemp = OF.estimateFlow(f(:,:,ii));
    flow(:,:,1,ii-1) = flowtemp.Vx;
    flow(:,:,2,ii-1) = flowtemp.Vy;
end
end