function [uSeq, cSeq, vSeq, wSeq] = FindMaskSeq(f, lambda, epsilon, mu, nMax, nOpt)

% Copyright 2018 Laurent Hoeltgen <contact@laurenthoeltgen.name>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision on: 18.05.2018 13:53

cSeq = zeros(size(f),'like',f); % mask
uSeq = zeros(size(f),'like',f); % solutions of optimal control model
vSeq = zeros(size(f),'like',f); % solutions with gray value optimisation
wSeq = zeros(size(f),'like',f); % solutions with gray value optimisation and binarisation
                                % of the mask.
for ii = 1:size(f,3)
    % [u, c, reco, reco + gvo, rec/bin, reco/bin + gvo]
    [uSeq(:,:,ii), cSeq(:,:,ii), ~, vSeq(:,:,ii), ~, wSeq(:,:,ii)] = ...
        FindMaskOld(f(:,:,ii), lambda, epsilon, mu, nMax, nOpt);
end

cSeq(cSeq >  0.0001) = 1;
cSeq(cSeq <= 0.9999) = 0;
end