function [ out ] = avgEndPtErr( uTest, vTest, uGt, vGt, mask )
%% avgEndPtErr computes the Average Endpoint Error of testdata compared to a groundtruth

% Copyright 2017-2018 Georg Radow <radow@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision on: 02.02.2018 09:11

dim=size(uTest);
if ~isequal(dim,size(vTest),size(uGt),size(vGt))
    error('all input data must have the same size')
end

out = 1/(dim(1)*dim(2)-sum(sum(mask==0)))*sum(sum(sqrt( ...
    (uTest(mask==1)-uGt(mask==1)).^2+(vTest(mask==1)-vGt(mask==1)).^2)));

end
