% Copyright 2018 Laurent Hoeltgen <contact@laurenthoeltgen.name>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision on: 07.06.2018 16:22

aae = nan(14,1);
for ii = 1:14
    vcx = fu(:,:,ii);
    vcy = fv(:,:,ii);
    
    vex = flow(:,:,1,ii);
    vey = flow(:,:,2,ii);
    tmp = arrayfun(@(x) real(acos(x))*180/pi, ...
        (vcx.*vex + vcy.*vey + 1)./(sqrt(vcx.^2 + vcy.^2 + 1).*sqrt(vex.^2 + vey.^2 + 1)));
    aae(ii) = sum(tmp(:))/numel(vcx);
end

aee = nan(14,1);
for ii = 1:14
    vcx = fu(:,:,ii);
    vcy = fv(:,:,ii);
    vex = flow(:,:,1,ii);
    vey = flow(:,:,2,ii);
    aee(ii) = sum(sqrt((vcx(:)-vex(:)).^2 + (vcy(:) - vey(:)).^2))/numel(vcx);
end

aaec = nan(14,1);
for ii = 1:14
    vcx = fu(:,:,ii);
    vcy = fv(:,:,ii);
    
    vex = flow(:,:,1,ii);
    vey = flow(:,:,2,ii);
    tmp = arrayfun(@(x) real(acos(x))*180/pi, ...
        (vcx.*vex + vcy.*vey + 1)./(sqrt(vcx.^2 + vcy.^2 + 1).*sqrt(vex.^2 + vey.^2 + 1)));
    m = c(:,:,ii);
    aaec(ii) = sum(tmp(abs(m)>0))/sum(abs(m(:))>0);
end

aeec = nan(14,1);
for ii = 1:14
    vcx = fu(:,:,ii);
    vcy = fv(:,:,ii);
    vex = flow(:,:,1,ii);
    vey = flow(:,:,2,ii);
    m = c(:,:,ii);
    aeec(ii) = sum(sqrt((vcx(abs(m)>0)-vex(abs(m)>0)).^2 + (vcy(abs(m)>0) - vey(abs(m)>0)).^2))/sum(abs(m(:))>0);
end