function [aae, aee, aaec, aeec] = computeflowerror(gt, fl, c)

% Copyright 2019 Laurent Hoeltgen <contact@laurenthoeltgen.name>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision on: 19.08.19 11:22

aae = nan(size(gt,4),1);
aaec = aae;
for ii = 1:size(gt,4)
    vcx = gt(:,:,1,ii);
    vcy = gt(:,:,2,ii);
    
    vex = fl(:,:,1,ii);
    vey = fl(:,:,2,ii);
    
    tmp = arrayfun(@(x) real(acos(x))*180/pi, ...
        (vcx.*vex + vcy.*vey + 1)./ ...
        (sqrt(vcx.^2 + vcy.^2 + 1).*sqrt(vex.^2 + vey.^2 + 1)));
    tmp2 = c(:,:,ii);
    aae(ii)  = sum(tmp(:))/numel(vcx);
    aaec(ii) = sum(tmp(:).*tmp2(:))/sum(tmp2(:)>0);
end

aee = nan(size(gt,4),1);
aeec = aee;
for ii = 1:size(gt,4)
    vcx = gt(:,:,1,ii);
    vcy = gt(:,:,2,ii);
    
    vex = fl(:,:,1,ii);
    vey = fl(:,:,2,ii);
    
    aee(ii) = sum(sqrt((vcx(:)-vex(:)).^2 + (vcy(:) - vey(:)).^2))/numel(vcx);
    tmp2 = c(:,:,ii);
    aeec(ii) = sum(sqrt((vcx(tmp2(:)>0)-vex(tmp2(:)>0)).^2 + ...
        (vcy(tmp2(:)>0) - vey(tmp2(:)>0)).^2))/numel(vcx(tmp2(:)>0));
end
end