function [aae, aee, aaec, aeec] = computeflowerrorAlt(flowgt, flow, c)
%% error value for full images and and mask locations

% Copyright 2019 Georg Radow <radow@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision on: 30.07.2019 15:42

%% computation
[nr, nc, ~, nimg] = size(flowgt);
aae = zeros(nimg,1);
aee = zeros(nimg,1);
aaec = zeros(nimg,1);
aeec = zeros(nimg,1);

for kk=1:nimg
    aae(kk) = avgAngErr( flow(:,:,1,kk), flow(:,:,2,kk), flowgt(:,:,1,kk), flowgt(:,:,2,kk), ones(nr,nc) );
    aee(kk) = avgEndPtErr( flow(:,:,1,kk), flow(:,:,2,kk), flowgt(:,:,1,kk), flowgt(:,:,2,kk), ones(nr,nc) );
    aaec(kk) = avgAngErr( flow(:,:,1,kk), flow(:,:,2,kk), flowgt(:,:,1,kk), flowgt(:,:,2,kk), c(:,:,kk) );
    aeec(kk) = avgEndPtErr( flow(:,:,1,kk), flow(:,:,2,kk), flowgt(:,:,1,kk), flowgt(:,:,2,kk), c(:,:,kk) );
end


end