function [v, err] = rebuildVideo(c, f)

[nr, nc, nd] = size(f);
nn = nr*nc;

D1y   = sparse(1:(nr-1), 2:nr, 1, nr, nr) - speye(nr, nr); D1y(nr, nr) = 0;
D1x   = sparse(1:(nc-1), 2:nc, 1, nc, nc) - speye(nc, nc); D1x(nc, nc) = 0;
DxDy  = [ kron(D1x, speye(nr,nr)) ;  kron(speye(nc,nc), D1y) ];
Dxxyy = -DxDy'*DxDy;

v   = zeros(size(f));
err = zeros(1,nd);

for ii = 1:nd
    tmp  = c(:, :, ii);
    tmp2 = f(:, :, ii);
    %
    A = sparse(1:nn, 1:nn, tmp(:)) + ...
        (speye(nn,nn) - sparse(1:nn, 1:nn, tmp(:)))*(-Dxxyy);
    
    v(:, :, ii) = reshape(gvo(A, tmp, tmp2), [nr, nc]);
    % v(:, :, ii) = reshape(A\(tmp(:).*tmp2(:)), [nr, nc]);
    err(ii) = norm(v(:,:,ii) - f(:,:,ii),'fro')^2/(nr*nc);
end
end

function v = gvo(A, c, f)

dA = decomposition(A);

[g, flag] = lsqr(@afunA, f(:), 1.0e-10, 360);
if flag > 1
    error('Something went wrong');
end

v = dA\(c(:).*g(:));

    function y = afunA(x,transp_flag)
        if strcmp(transp_flag,'transp')      % y = A'*x
            y = c(:).*((dA')\x);
        elseif strcmp(transp_flag,'notransp') % y = A*x
            y = dA\(c(:).*x);
        end
    end
end